package de.intevation.flys.importer;

import de.intevation.flys.model.MainValueType;

import org.hibernate.Session;
import org.hibernate.Query;

import java.util.List;

public class ImportMainValueType
implements   Comparable<ImportMainValueType>
{
    protected String value;

    protected MainValueType peer;

    public ImportMainValueType() {
    }

    public ImportMainValueType(String value) {
        this.value = value;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public int compareTo(ImportMainValueType other) {
        return value.compareTo(other.value);
    }

    @Override
    public boolean equals(Object other) {
        if (other == this) return true;
        if (!(other instanceof ImportMainValueType)) return false;
        return value.equals(((ImportMainValueType)other).value);
    }

    @Override
    public int hashCode() {
        return value.hashCode();
    }

    public MainValueType getPeer() {
        if (peer == null) {
            Session session = Importer.sessionHolder.get();
            Query query = session.createQuery("from MainValueType where value=:value");
            query.setString("value", value);
            List<MainValueType> values = query.list();
            if (values.isEmpty()) {
                peer = new MainValueType(value);
                session.save(peer);
            }
            else {
                peer = values.get(0);
            }
        }
        return peer;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
