package de.intevation.flys.importer;

import de.intevation.flys.model.Range;
import de.intevation.flys.model.River;

import org.hibernate.Session;
import org.hibernate.Query;

import java.util.List;

import java.math.BigDecimal;

import org.apache.log4j.Logger;

public class ImportRange
implements   Comparable<ImportRange>
{
    private static Logger log = Logger.getLogger(ImportRange.class);

    protected BigDecimal a;
    protected BigDecimal b;

    protected Range peer;

    public ImportRange() {
    }

    public ImportRange(BigDecimal a, BigDecimal b) {
        this.a = a;
        this.b = b;
    }

    private static final int compare(BigDecimal a, BigDecimal b) {
        if (a == null && b == null) {
            return 0;
        }
        if (a == null && b != null) {
            return -1;
        }
        if (a != null && b == null) {
            return +1;
        }
        return a.compareTo(b);
    }

    public int compareTo(ImportRange other) {
        int cmp = compare(a, other.a);
        if (cmp != 0) return cmp;
        return compare(b, other.b);
    }

    public BigDecimal getA() {
        return a;
    }

    public void setA(BigDecimal a) {
        this.a = a;
    }

    public BigDecimal getB() {
        return b;
    }

    public void setB(BigDecimal b) {
        this.b = b;
    }

    public Range getPeer(River river) {
        if (peer == null) {
            Session session = Importer.sessionHolder.get();
            Query query = session.createQuery(
                "from Range where a=:a and b=:b and river.id=:river");
            query.setParameter("a", a);
            query.setParameter("b", b);
            query.setParameter("river", river.getId());
            List<Range> ranges = query.list();
            if (ranges.isEmpty()) {
                peer = new Range(a, b, river);
                session.save(peer);
            }
            else {
                peer = ranges.get(0);
            }
        }
        return peer;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
